<script lang="ts">
import { Prop, Component } from 'vue-property-decorator';
import type {
  Label, Pixel, Unit, LabelId,
} from '@/data';
import { PixelUnitWithSeconds } from '@/data';
import type { SyncLabel } from '@/synchronization-logic/SynchronizationActions';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import type { BEdgeDragEmitter } from '../scroll/BScrollOnEdgeDrag.vue';
import type { CanvasMouseEvent } from '../LabelBehavior.vue';
import LabelBehavior from '../LabelBehavior.vue';

interface State {
  id: LabelId;
  offset: Pixel;
  repeat?: string;
}

/**
 * On drag click over a label, move the label
 *
 * Can move along a line and/or from line to line
 */
@Component
export default class BEditSyncOnDrag extends LabelBehavior<BEdgeDragEmitter> {
  @Prop()
  pixelUnit!: Unit<Pixel>;

  @Prop({ required: false })
  actions!: SynchronizationActions;

  state: State | null = null;

  startDrag(event: CanvasMouseEvent, label: Label): void {
    if (label.repeat !== this.actions.currentSelectedRepeat) return;
    const syncPixelPos = this.pixelUnit.fromOnset(label.onset);
    const offset = (syncPixelPos.value - event.x) as Pixel;
    const { id, repeat } = label as SyncLabel;
    this.state = { id, offset, repeat };
  }

  dragHorizontal(event: CanvasMouseEvent): void {
    if (this.state === null) return;

    try {
      const x = (event.x + this.state.offset) as Pixel;
      this.emit('check-edge-drag', x);

      // If currently on a waveform of the track being editing, convert directly from event pixel
      if (PixelUnitWithSeconds.isUnitWithSeconds(this.pixelUnit)) {
        // Get second from the waveform unit
        const timestamp = this.pixelUnit.fromPixelToSecond(event.x);
        // Modify the sync point
        this.actions.setSyncPointSecond(this.state.id, timestamp, 1 / 10);
      } else {
        // Convert to common musical time
        const onset = this.pixelUnit.toOnset(x, true).value;
        // Snap to closest note
        const snappedOnset = this.pixelUnit.snapOnset(onset);
        // Modify the sync point
        this.actions.setSyncPointOnset(this.state.id, snappedOnset, 1 / 4);
      }
    } catch (e) {
      // eslint-disable-next-line no-console
      console.error('Actions impl could not bound values: ', (e as Error).message);
    }
  }

  endDrag() {
    this.state = null;
  }

  mounted() {
    this.register('left-arrow-mousedown', this.startDrag);
    this.register('right-arrow-mousedown', this.startDrag);
    this.register('label-mousedown', this.startDrag);
    this.register('all-mousemove', this.dragHorizontal);
    this.register('document-mouseup', this.endDrag);
  }
}
</script>
